import type { GomokuDirectionType } from './constant';
import type { IGomokuContext } from './context.type';
import type { IGomokuCountMap } from './count-map.type';
export declare class GomokuCountMap implements IGomokuCountMap {
    readonly context: Readonly<IGomokuContext>;
    protected readonly _mustDropPosSet: Array<Set<number>>;
    protected readonly _candidateCouldReachFinal: number[][];
    constructor(context: Readonly<IGomokuContext>);
    init(): void;
    forward(posId: number): void;
    revert(posId: number): void;
    mustDropPos(playerId: number): Iterable<number> & {
        size: number;
    };
    candidateCouldReachFinal(playerId: number, posId: number): boolean;
    protected _updateRelatedCouldReachFinal(centerPosId: number): void;
    protected _updateCouldReachFinal(posId: number, expiredBitset: number): void;
    protected _couldReachFinalInDirection(playerId: number, posId: number, dirType: GomokuDirectionType): boolean;
}
