import type { IDeepSearcherProps } from '../search/deep';
import type { INarrowSearcherProps } from '../search/narrow';
import type { IMinimaxSearcher, IMinimaxSearcherContext, IShapeScoreMap } from '../types';
export declare type INarrowSearchOption = Omit<INarrowSearcherProps, 'searchContext' | 'deeperSearcher'>;
export declare type IDeepSearcherOption = Omit<IDeepSearcherProps, 'searchContext'>;
interface IProps {
    narrowSearcherOptions: INarrowSearchOption[];
    deepSearcherOption: IDeepSearcherOption;
    searchContext: IMinimaxSearcherContext;
}
export declare const createMinimaxSearcher: (props: IProps) => IMinimaxSearcher;
export declare const createDefaultMinimaxSearcher: (scoreMap: Readonly<IShapeScoreMap>, searchContext: IMinimaxSearcherContext, options: {
    MAX_ADJACENT: number;
    MIN_MULTIPLE_OF_TOP_SCORE: number;
}) => IMinimaxSearcher;
export {};
